#ifndef _DECL_RandCentLB_H_
#define _DECL_RandCentLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group RandCentLB: CentralLB{
void RandCentLB(void);
};
 */
class RandCentLB;
class CProxy_RandCentLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_RandCentLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_RandCentLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    RandCentLB* ckLocalBranch(void) {
      return (RandCentLB *) CkLocalBranch(_ck_gid);
    }
    static RandCentLB* ckLocalBranch(CkGroupID gID) {
      return (RandCentLB *) CkLocalBranch(gID);
    }
/* DECLS: void RandCentLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_RandCentLB(int retEP, CkChareID *cid);
    CProxy_RandCentLB(void);
    static int  __idx_RandCentLB_void;
    static int  ckIdx_RandCentLB(void) { return __idx_RandCentLB_void; }
    static void _call_RandCentLB_void(void* msg, RandCentLB* obj);
};

extern void _registerRandCentLB(void);
#endif
